#pragma once

#include "SpielKlasse.h"
#include <Datei.h>

class Statistik;
class StatistikV;

class Spiel : public SpielKlasse
{
private:
    int ref;

public:
    // Konstruktor
    Spiel();
    // Destruktor
    ~Spiel();
    // nicht constant
    void setPSQLK( SSDatenbankV *psqldb ) override; // call 1
    void setSpielId( int id ) override; // call 2
    void setKarteId( int karteId ) override; // call 3
    void setTempPfad( char *pfad ) override; // call 3.5
    void setAccounts( int anzahl, Array< int > *zAccounts ) override; // call 4
    void setKlients( int anzahl, RCArray< SSKlientV > *zKlients ) override; // call 5
    void setSpielerNummern( int anzahl, Array< int > *spielerNummern ) override; // call 6
    void klientOffline( int accountId ) override;
    void klientOnline( int accountId, SSKlientV *zKlient ) override;
    void nachricht( int accountId, int len, char *bytes ) override;
    void tick( double zeit );
    void run() override; // call 7
                // constant
    StatistikV *getStatistik() const override;
    // Reference Counting 
    SpielKlasse *getThis() override;
    SpielKlasse *release() override;
};