#pragma once

#include <Text.h>

using namespace Framework;

enum VariableTyp
{
    NICHTS,
    INTEGER,
    BOOLEAN,
    STRING,
    RICHTUNG,
    FLOAT,
    TASTE,
    SPIELER,
    TIMER,
    TEAM,
    BARIERE,
    SCHALTER,
    BASE,
    GEGENSTAND,
    SCHIENE,
    TUNNEL,
    UMLENKUNG,
    TRIGGER
};

class Variable
{
private:
    VariableTyp typ;
    int ref;

public:
    Variable( VariableTyp typ );
    virtual ~Variable();
    VariableTyp getTyp() const;
    Variable *getThis();
    Variable *release();
};

class Integer : public Variable
{
private:
    int value;

public:
    Integer( bool taste = 0 );
    void setValue( int value );
    int getValue() const;
};

class Boolean : public Variable
{
private:
    bool value;

public:
    Boolean();
    void setValue( bool value );
    bool getValue() const;
};

class String : public Variable
{
private:
    Text value;

public:
    String( bool richtung = 0 );
    void setValue( Text value );
    const Text &getValue() const;
};

class Float : public Variable
{
private:
    float value;

public:
    Float();
    void setValue( float value );
    float getValue() const;
};